---

.shared:
  based_on:
    - .dag.object_cache.use
    - .dag.meta_ops.round_coordinate_values
    # - .dag.object_cache.clear

  # select_and_combine:
  #   subspace:
  #     frac_up: !sweep
  #       default: 0.5
  #       values: [0.0, 0.5, 1.0]

  # no longer needed with simulation storing the stable state already:
  # dag_options:
  #   define:
  #     num_samples: 10  # .. because write_every is larger


.shared.pub:
  based_on:
    - .pubfig.single

  # select_and_combine:
  #   subspace:
  #     # beta:
  #     #   - !sweep
  #     #     name: beta
  #     #     default: 1.0
  #     #     values: [0.5, 1.0, 1.3, 1.5, 2.0]
  #     frac_up:
  #       - !sweep
  #         name: frac_up
  #         default: 0.5
  #         values: [0.0, 0.5, 1.0]

  helpers:
    set_limits:
      x: [0, 0.34]



# -----------------------------------------------------------------------------

stable_state_magnetization: true


stable_state_magnetization_averaged: #!pspace
  based_on:
    - .shared
    - stable_state_magnetization_averaged
    # - .plot.facet_grid.errorbands

  transform:
    - define: !dag_tag _data
      file_cache:
        read: true
        write: true
    # - .isel: [!dag_prev , {frac_unbiased: !slice [0, -1]}]
    #   allow_failure: true
    #   fallback: !dag_prev
    - .squeeze_with_drop
    - .round_coordinate_values: [!dag_prev , frac_unbiased, 5]
    - .round_coordinate_values: [!dag_prev , omega_down, 5]
      tag: data

  x: p_flip_random
  hue: frac_unbiased
  col_wrap: auto

  marker: "."
  ms: 2.5

  linewidth: 0
  elinewidth: 0.5
  alpha: 0.8

  add_legend: false

  helpers:
    axis_specific:
      [0, 0]:
        set_legend:
          title: $\rho_0$
          ncols: 2
          fontsize: xx-small
          loc: lower right

    # set_scales:
    #   x: log

    set_labels:
      x: noise level
      y: $m$
      only_label_outer: true


stable_state_magnetization_heatmap: #!pspace
  based_on:
    - .shared
    - stable_state_magnetization_heatmap

  dag_options:
    define:
      hist_bins: 100   # use even number to see bias around 0

  x: p_flip_random
  add_colorbar: false


# -- Selected individual plots ------------------------------------------------
# ... for publication


fig/weakly_biased/ssma_rho0: !pspace
  based_on:
    - stable_state_magnetization_averaged
    - .shared.pub

  # select_and_combine:
  #   subspace:
  #     # omega_down: [0.3]
  #     frac_up: [0.0]


fig/weakly_biased/ssma_omega: !pspace
  based_on:
    - stable_state_magnetization_averaged
    - .shared.pub

  # select_and_combine:
  #   subspace:
  #     frac_unbiased: [0.3]

  hue: omega_down

  helpers:
    axis_specific:
      [0, 0]:
        set_legend:
          title: $\omega_-$
